/*
* Alabastra Project - C++ Editor writed with QT Library V.4
* Copyright (C) Igor Maculan - geocronos@gmail.com
			 
   
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*  
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "AlGoToLine.h"
#include <QTextCursor>

AlGoToLine::AlGoToLine(QWidget *parent,AlTextEdit *a_txt) : QDialog( parent) {
	ui.setupUi(this);
	ui.sld->setMinimum(0);
	txt=a_txt;
	QTextCursor c=txt->textCursor();
	c.movePosition(QTextCursor::End);
	ui.sld->setMaximum(c.blockNumber());
	connect (ui.sld,SIGNAL(sliderMoved(int)),this,SLOT(slideMoved(int)));
	connect (ui.btn_go,SIGNAL(clicked()),this,SLOT(goToLine()));
	ui.edt_row->selectAll();
};

void AlGoToLine::slideMoved(int r){
	ui.edt_row->setText(QString("%1").arg(r));
	ui.edt_row->selectAll();
};

void AlGoToLine::goToLine(){
	bool convOk=false;
	int k=ui.edt_row->text().toInt(&convOk,10);
	if (convOk){
		emit (lineSelected(k));
	}
};
