/*
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - geocronos@gmail.com
			Marco Buoncristiano - marco.buoncristiano@gmail.com

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef ALPROJECT_H
#define ALPROJECT_H

#include <QObject>
#include <QList>
#include "AlDocument.h"

struct author{
	QString name;
	QString email;
};

struct prjfile{
	QString filename;
};

class AlProject : public QObject {
	Q_OBJECT
	private:
		QString filename;
		QString name;
		QString path;
		QString compileStr;
		QString makeStr;
		QString execStr;
		QString header;
		QList<prjfile> prjFiles;
		QList<author> authors;
	public:
		AlProject();
		bool open(QString);
		QList<prjfile> getFiles();
		void makeHeader();
		QString getHeader();
};

#endif
