/* 
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - geocronos@gmail.com
			Marco Buoncristiano - marco.buoncristiano@gmail.com

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef ALWINMAIN_H
#define ALWINMAIN_H

#include <QMainWindow>
#include <QMessageBox>
#include <QVariant>
#include <QFileDialog>
#include <QCloseEvent>
#include <QPrinter>
#include <QAction>
#include "AlProject.h"
#include "AlDocument.h"
#include "AlSearch.h"

#include "ui_AlWinMain.h"
using namespace Ui;

class QTextEdit;

class AlWinMain : public QMainWindow
{
	Q_OBJECT
	private:
		QAction *newAction;
		QString fname;
		AlWinMain_ui ui; //UserInterface
		void connect_action(); //collega le azioni agli slot relativi
		AlProject *prj;
		QFileDialog *exportdlg;
		AlSearch *srcWin;
		AlTextEdit *actualTxt;
		void connectEditor(AlTextEdit*);
		void disConnectEditor(AlTextEdit*);
		QString lastOpenDir; //memorizza l'ultima directory dove' stato fatto un apri cos da riutilizzarla all'apri o salva successivo
	public:
		AlWinMain(); //Costruttore
	protected:
		void closeEvent(QCloseEvent*);
	public slots:
		void new_file();
		void view_file(QListWidgetItem*);
		void view_file(AlTextEdit*);
		void view_file(int);
		void save_as(AlDocument*);
		void save_as();
		void save();
		void saveall();
		void save(AlTextEdit*);
		void save(AlDocument*);
		void changeFileName(AlTextEdit*);
		void open();
		void reload(); //riapre il file attuale
		void closeTab();
		bool closeFile(QListWidgetItem*);
		void closeFile();
		bool closeAll();
		void showPosition();
		void about();
		void openPrjManager();
		void openProject();
		void loadFromProject(AlProject*);
		void insertDateTime();
		void insertComment();
		void openfile(QString);
		void esporta();
		void expor();
		void showNotEnabled();
		void showSearch();
		void findNext();
		void findPrev();
		void showGoToLine();
		void goToLine(int);
		void goToMethod(QListWidgetItem*);
		void print();
		void direction();
		void refresh();
		void cancella();
		void modifiedDocument(AlDocument*,bool);
		void refreshMethodList();
		void iconsAD();
		void insertText(QString);
	
};

#endif
