/*
* Alabastra Project - C++ Editor writed with QT Library V.4 
* Copyright (C) Igor Maculan - geocronos@gmail.com

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <QApplication>
#include <QSplashScreen>
#include <QPixmap>
#include <QTimer>
#include <QPlastiqueStyle>
#include <QWindowsXPStyle>
#include "AlWinMain.h"

int main (int argc, char** argv)
{
	QApplication app(argc,argv);
	#ifdef Q_WS_X11
		app.setStyle(new QPlastiqueStyle);
	#endif
	#ifdef Q_WS_WIN
		app.setStyle(new QWindowsXPStyle);
	#endif
	QPixmap title("icons/splash_screen");
	QSplashScreen *splash = new QSplashScreen(title);
	splash->show();
	splash->showMessage("Version 0.1Alfa");
	QTimer::singleShot(1000, splash, SLOT(close()));
	AlWinMain *mainwin=new AlWinMain();
	mainwin->show();
	return app.exec();
}
